Index: inc/admin/lib.dc.page.php
===================================================================
--- inc/admin/lib.dc.page.php	(revision 3791)
+++ inc/admin/lib.dc.page.php	(revision 3878)
@@ -14,13 +14,13 @@
 class dcPage
 {
-    private static $loaded_js     = array();
-    private static $loaded_css    = array();
+    private static $loaded_js     = [];
+    private static $loaded_css    = [];
     private static $xframe_loaded = false;
-    private static $N_TYPES       = array(
+    private static $N_TYPES       = [
         "success" => "success",
         "warning" => "warning-msg",
         "error"   => "error",
         "message" => "message",
-        "static"  => "static-msg");
+        "static"  => "static-msg"];
 
     # Auth check
@@ -53,5 +53,5 @@
 
     # Top of admin page
-    public static function open($title = '', $head = '', $breadcrumb = '', $options = array())
+    public static function open($title = '', $head = '', $breadcrumb = '', $options = [])
     {
         global $core;
@@ -68,6 +68,6 @@
             $blog_box .= '</p>';
         } else {
-            $rs_blogs = $core->getBlogs(array('order' => 'LOWER(blog_name)', 'limit' => 20));
-            $blogs    = array();
+            $rs_blogs = $core->getBlogs(['order' => 'LOWER(blog_name)', 'limit' => 20]);
+            $blogs    = [];
             while ($rs_blogs->fetch()) {
                 $blogs[html::escapeHTML($rs_blogs->blog_name . ' - ' . $rs_blogs->blog_url)] = $rs_blogs->blog_id;
@@ -84,5 +84,5 @@
 
         # Display
-        $headers = new ArrayObject(array());
+        $headers = new ArrayObject([]);
 
         # Content-Type
@@ -102,5 +102,5 @@
         if (!$safe_mode && $core->blog->settings->system->csp_admin_on) {
             // Get directives from settings if exist, else set defaults
-            $csp = new ArrayObject(array());
+            $csp = new ArrayObject([]);
 
                                                                                 // SQlite Clearbricks driver does not allow using single quote at beginning or end of a field value
@@ -135,5 +135,5 @@
 
             // Construct CSP header
-            $directives = array();
+            $directives = [];
             foreach ($csp as $key => $value) {
                 if ($value) {
@@ -168,6 +168,8 @@
 
         if ($core->auth->user_prefs->interface->darkmode) {
+            echo self::jsVars(['dotclear_darkMode' => 1]);
             echo self::cssLoad('style/default-dark.css');
         } else {
+            echo self::jsVars(['dotclear_darkMode' => 0]);
             echo self::cssLoad('style/default.css');
         }
@@ -220,8 +222,7 @@
         '<li><a href="#content">' . __('Go to the content') . '</a></li>' .
         '<li><a href="#main-menu">' . __('Go to the menu') . '</a></li>' .
-        '<li><a href="#qx">' . __('Go to search') . '</a></li>' .
         '<li><a href="#help">' . __('Go to help') . '</a></li>' .
         '</ul>' . "\n" .
-        '<div id="header" role="banner">' .
+        '<header id="header" role="banner">' .
         '<h1><a href="' . $core->adminurl->get("admin.home") . '"><span class="hidden">' . DC_VENDOR_NAME . '</span></a></h1>' . "\n";
 
@@ -236,8 +237,8 @@
         '<li><a class="smallscreen' . (preg_match('/' . preg_quote($core->adminurl->get('admin.user.preferences')) . '(\?.*)?$/', $_SERVER['REQUEST_URI']) ? ' active' : '') .
         '" href="' . $core->adminurl->get("admin.user.preferences") . '">' . __('My preferences') . '</a></li>' .
-        '<li><a href="' . $core->adminurl->get("admin.home", array('logout' => 1)) . '" class="logout"><span class="nomobile">' . sprintf(__('Logout %s'), $core->auth->userID()) .
+        '<li><a href="' . $core->adminurl->get("admin.home", ['logout' => 1]) . '" class="logout"><span class="nomobile">' . sprintf(__('Logout %s'), $core->auth->userID()) .
             '</span><img src="images/logout.png" alt="" /></a></li>' .
             '</ul>' .
-            '</div>'; // end header
+            '</header>'; // end header
 
         echo
@@ -247,5 +248,5 @@
         '<img class="expand-mm visually-hidden" src="images/collapser-show.png" alt="' . __('Show main menu') . '" />' .
             '</button></div>' .
-            '<div id="main" role="main">' . "\n" .
+            '<main id="main" role="main">' . "\n" .
             '<div id="content" class="clearfix">' . "\n";
 
@@ -302,5 +303,5 @@
     }
 
-    public static function addNotice($type, $message, $options = array())
+    public static function addNotice($type, $message, $options = [])
     {
         if (isset(self::$N_TYPES[$type])) {
@@ -312,8 +313,8 @@
             $notifications = $_SESSION['notifications'];
         } else {
-            $notifications = array();
-        }
-
-        $n = array_merge($options, array('class' => $class, 'ts' => time(), 'text' => $message));
+            $notifications = [];
+        }
+
+        $n = array_merge($options, ['class' => $class, 'ts' => time(), 'text' => $message]);
         if ($type != "static") {
             $notifications[] = $n;
@@ -324,15 +325,15 @@
     }
 
-    public static function addSuccessNotice($message, $options = array())
+    public static function addSuccessNotice($message, $options = [])
     {
         self::addNotice("success", $message, $options);
     }
 
-    public static function addWarningNotice($message, $options = array())
+    public static function addWarningNotice($message, $options = [])
     {
         self::addNotice("warning", $message, $options);
     }
 
-    public static function addErrorNotice($message, $options = array())
+    public static function addErrorNotice($message, $options = [])
     {
         self::addNotice("error", $message, $options);
@@ -367,7 +368,7 @@
         echo
         "</div>\n" . // End of #content
-        "</div>\n" . // End of #main
-
-        '<div id="main-menu" role="navigation">' . "\n" .
+        "</main>\n" . // End of #main
+
+        '<nav id="main-menu" role="navigation">' . "\n" .
 
         '<form id="search-menu" action="' . $core->adminurl->get("admin.search") . '" method="get" role="search">' .
@@ -390,5 +391,5 @@
 
         echo
-        '</div>' . "\n" . // End of #main-menu
+        '</nav>' . "\n" . // End of #main-menu
         "</div>\n";       // End of #wrapper
 
@@ -409,7 +410,7 @@
 
         echo
-            '<div id="footer" role="contentinfo">' .
+            '<footer id="footer" role="contentinfo">' .
             '<a href="http://dotclear.org/" title="' . $text . '">' .
-            '<img src="style/dc_logos/w-dotclear90.png" alt="' . $text . '" /></a></div>' . "\n" .
+            '<img src="style/dc_logos/w-dotclear90.png" alt="' . $text . '" /></a></footer>' . "\n" .
             "<!-- " . "\n" .
             $figure .
@@ -448,6 +449,8 @@
 
         if ($core->auth->user_prefs->interface->darkmode) {
+            echo self::jsVars(['dotclear_darkMode' => 1]);
             echo self::cssLoad('style/default-dark.css');
         } else {
+            echo self::jsVars(['dotclear_darkMode' => 0]);
             echo self::cssLoad('style/default.css');
         }
@@ -494,5 +497,5 @@
         echo
             '<div id="wrapper">' . "\n" .
-            '<div id="main" role="main">' . "\n" .
+            '<main id="main" role="main">' . "\n" .
             '<div id="content">' . "\n";
 
@@ -508,14 +511,14 @@
         echo
         "</div>\n" . // End of #content
-        "</div>\n" . // End of #main
+        "</main>\n" . // End of #main
         "</div>\n" . // End of #wrapper
 
         '<p id="gototop"><a href="#wrapper">' . __('Page top') . '</a></p>' . "\n" .
 
-            '<div id="footer" role="contentinfo"><p>&nbsp;</p></div>' . "\n" .
+            '<footer id="footer" role="contentinfo"><p>&nbsp;</p></footer>' . "\n" .
             '</body></html>';
     }
 
-    public static function breadcrumb($elements = null, $options = array())
+    public static function breadcrumb($elements = null, $options = [])
     {
         global $core;
@@ -616,5 +619,5 @@
     }
 
-    public static function helpBlock()
+    public static function helpBlock(...$params)
     {
         global $core;
@@ -624,6 +627,5 @@
         }
 
-        $args = func_get_args();
-        $args = new ArrayObject($args);
+        $args = new ArrayObject($params);
 
         # --BEHAVIOR-- adminPageHelpBlock
@@ -740,5 +742,5 @@
             }
         } else {
-            $unfolded_sections = array();
+            $unfolded_sections = [];
         }
         return '<script type="text/javascript">' . "\n" .
@@ -763,4 +765,5 @@
         self::jsLoad('js/jquery/jquery.biscuit.js') .
         self::jsLoad('js/common.js') .
+        self::jsLoad('js/services.js') .
         self::jsLoad('js/prelude.js') .
 
@@ -911,14 +914,13 @@
     }
 
-    public static function jsConfirmClose()
-    {
-        $args = func_get_args();
+    public static function jsConfirmClose(...$args)
+    {
         if (count($args) > 0) {
             foreach ($args as $k => $v) {
                 $args[$k] = "'" . html::escapeJS($v) . "'";
             }
-            $args = implode(',', $args);
+            $params = implode(',', $args);
         } else {
-            $args = '';
+            $params = '';
         }
 
@@ -926,5 +928,5 @@
         self::jsLoad('js/confirm-close.js') .
         '<script type="text/javascript">' . "\n" .
-        "confirmClosePage = new confirmClose(" . $args . "); " .
+        "confirmClosePage = new confirmClose(" . $params . "); " .
         "confirmClose.prototype.prompt = '" . html::escapeJS(__('You have unsaved changes.')) . "'; " .
             "</script>\n";
@@ -1002,5 +1004,5 @@
     }
 
-    public static function jsUpload($params = array(), $base_url = null)
+    public static function jsUpload($params = [], $base_url = null)
     {
         if (!$base_url) {
@@ -1008,9 +1010,9 @@
         }
 
-        $params = array_merge($params, array(
+        $params = array_merge($params, [
             'sess_id=' . session_id(),
             'sess_uid=' . $_SESSION['sess_browser_uid'],
             'xd_check=' . $GLOBALS['core']->getNonce()
-        ));
+        ]);
 
         return
@@ -1067,5 +1069,5 @@
     }
 
-    public static function jsLoadCodeMirror($theme = '', $multi = true, $modes = array('css', 'htmlmixed', 'javascript', 'php', 'xml'))
+    public static function jsLoadCodeMirror($theme = '', $multi = true, $modes = ['css', 'htmlmixed', 'javascript', 'php', 'xml'])
     {
         $ret =
@@ -1114,5 +1116,5 @@
     public static function getCodeMirrorThemes()
     {
-        $themes      = array();
+        $themes      = [];
         $themes_root = dirname(__FILE__) . '/../../admin' . '/js/codemirror/theme/';
         if (is_dir($themes_root) && is_readable($themes_root)) {
@@ -1131,10 +1133,10 @@
     public static function getPF($file)
     {
-        return $GLOBALS['core']->adminurl->get('load.plugin.file', array('pf' => $file));
+        return $GLOBALS['core']->adminurl->get('load.plugin.file', ['pf' => $file]);
     }
 
     public static function getVF($file)
     {
-        return $GLOBALS['core']->adminurl->get('load.var.file', array('vf' => $file));
+        return $GLOBALS['core']->adminurl->get('load.var.file', ['vf' => $file]);
     }
 
Index: inc/admin/lib.moduleslist.php
===================================================================
--- inc/admin/lib.moduleslist.php	(revision 3775)
+++ inc/admin/lib.moduleslist.php	(revision 3874)
@@ -23,8 +23,8 @@
 
     public static $allow_multi_install = false; /**< @var    boolean    Work with multiple root directories */
-    public static $distributed_modules = array(); /**< @var    array    List of modules distributed with Dotclear */
+    public static $distributed_modules = []; /**< @var    array    List of modules distributed with Dotclear */
 
     protected $list_id = 'unknow'; /**< @var    string    Current list ID */
-    protected $data    = array(); /**< @var    array    Current modules */
+    protected $data    = []; /**< @var    array    Current modules */
 
     protected $config_module  = ''; /**< @var    string    Module ID to configure */
@@ -42,5 +42,5 @@
 
     public static $nav_indexes = 'abcdefghijklmnopqrstuvwxyz0123456789'; /**< @var    string    Index list */
-    protected $nav_list        = array(); /**< @var    array    Index list with special index */
+    protected $nav_list        = []; /**< @var    array    Index list with special index */
     protected $nav_special     = 'other'; /**< @var    string    Text for other special index */
 
@@ -54,12 +54,13 @@
      *
      * @param    object    $modules        dcModules instance
-     * @param    string    $modules_root    Modules root directories
+     * @param    string    $modules_root   Modules root directories
      * @param    string    $xml_url        URL of modules feed from repository
-     */
-    public function __construct(dcModules $modules, $modules_root, $xml_url)
+     * @param    boolean   $force          Force query repository
+     */
+    public function __construct(dcModules $modules, $modules_root, $xml_url, $force = false)
     {
         $this->core    = $modules->core;
         $this->modules = $modules;
-        $this->store   = new dcStore($modules, $xml_url);
+        $this->store   = new dcStore($modules, $xml_url, $force);
 
         $this->page_url = $this->core->adminurl->get('admin.plugins');
@@ -77,5 +78,5 @@
     public function setList($id)
     {
-        $this->data     = array();
+        $this->data     = [];
         $this->page_tab = '';
         $this->list_id  = $id;
@@ -298,5 +299,5 @@
     {
         $this->nav_special = (string) $str;
-        $this->nav_list    = array_merge(str_split(self::$nav_indexes), array($this->nav_special));
+        $this->nav_list    = array_merge(str_split(self::$nav_indexes), [$this->nav_special]);
 
         return $this;
@@ -325,5 +326,5 @@
 
         # Fetch modules required field
-        $indexes = array();
+        $indexes = [];
         foreach ($this->data as $id => $module) {
             if (!isset($module[$this->sort_field])) {
@@ -340,5 +341,5 @@
         }
 
-        $buttons = array();
+        $buttons = [];
         foreach ($this->nav_list as $char) {
             # Selected letter
@@ -411,5 +412,5 @@
     public function setModules($modules)
     {
-        $this->data = array();
+        $this->data = [];
         if (!empty($modules) && is_array($modules)) {
             foreach ($modules as $id => $module) {
@@ -446,5 +447,5 @@
         return array_merge(
             # Default values
-            array(
+            [
                 'desc'              => '',
                 'author'            => '',
@@ -464,11 +465,11 @@
                 'score'             => 0,
                 'type'              => null,
-                'require'           => array(),
-                'settings'          => array()
-            ),
+                'require'           => [],
+                'settings'          => []
+            ],
             # Module's values
             $module,
             # Clean up values
-            array(
+            [
                 'id'    => $id,
                 'sid'   => self::sanitizeString($id),
@@ -476,5 +477,5 @@
                 'name'  => $name,
                 'sname' => self::sanitizeString($name)
-            )
+            ]
         );
     }
@@ -503,5 +504,5 @@
     public static function sortModules($modules, $field, $asc = true)
     {
-        $origin = $sorter = array();
+        $origin = $sorter = [];
 
         foreach ($modules as $id => $module) {
@@ -527,5 +528,5 @@
      * @return    adminModulesList self instance
      */
-    public function displayModules($cols = array('name', 'version', 'desc'), $actions = array(), $nav_limit = false)
+    public function displayModules($cols = ['name', 'version', 'desc'], $actions = [], $nav_limit = false)
     {
         echo
@@ -611,5 +612,5 @@
                 echo
                 '<td class="module-icon nowrap">' .
-                form::checkbox(array('modules[' . $count . ']', html::escapeHTML($this->list_id) . '_modules_' . html::escapeHTML($id)), html::escapeHTML($id)) .
+                form::checkbox(['modules[' . $count . ']', html::escapeHTML($this->list_id) . '_modules_' . html::escapeHTML($id)], html::escapeHTML($id)) .
                     '</td>';
             }
@@ -641,5 +642,5 @@
                 echo
                 html::escapeHTML($module['name']) . ($id != $module['name'] ? sprintf(__(' (%s)'), $id) : '') .
-                form::hidden(array('modules[' . $count . ']'), html::escapeHTML($id));
+                form::hidden(['modules[' . $count . ']'], html::escapeHTML($id));
             }
             echo
@@ -731,5 +732,5 @@
                     }
 
-                    $more = array();
+                    $more = [];
                     if (!empty($module['details'])) {
                         $more[] = '<a class="module-details" href="' . $module['details'] . '">' . __('Details') . '</a>';
@@ -820,5 +821,5 @@
     public static function getSettingsUrls($core, $id, $check = false, $self = true)
     {
-        $st = array();
+        $st = [];
 
         $mr       = $core->plugins->moduleRoot($id);
@@ -830,5 +831,5 @@
                     $core->auth->isSuperAdmin() ||
                     $core->auth->check($core->plugins->moduleInfo($id, 'permissions'), $core->blog->id)) {
-                    $params = array('module' => $id, 'conf' => '1');
+                    $params = ['module' => $id, 'conf' => '1'];
                     if (!$core->plugins->moduleInfo($id, 'standalone_config') && !$self) {
                         $params['redir'] = $core->adminurl->get('admin.plugin.' . $id);
@@ -889,5 +890,5 @@
     protected function getActions($id, $module, $actions)
     {
-        $submits = array();
+        $submits = [];
 
         # Use loop to keep requested order
@@ -951,5 +952,5 @@
     protected function getGlobalActions($actions, $with_selection = false)
     {
-        $submits = array();
+        $submits = [];
 
         # Use loop to keep requested order
@@ -1014,5 +1015,5 @@
         }
 
-        $modules = !empty($_POST['modules']) && is_array($_POST['modules']) ? array_values($_POST['modules']) : array();
+        $modules = !empty($_POST['modules']) && is_array($_POST['modules']) ? array_values($_POST['modules']) : [];
 
         if ($this->core->auth->isSuperAdmin() && !empty($_POST['delete'])) {
@@ -1286,9 +1287,9 @@
         '<input type="file" name="pkg_file" id="pkg_file" required /></p>' .
         '<p class="field"><label for="your_pwd1" class="classic required"><abbr title="' . __('Required field') . '">*</abbr> ' . __('Your password:') . '</label> ' .
-        form::password(array('your_pwd', 'your_pwd1'), 20, 255,
-            array(
+        form::password(['your_pwd', 'your_pwd1'], 20, 255,
+            [
                 'extra_html'   => 'required placeholder="' . __('Password') . '"',
                 'autocomplete' => 'current-password'
-            )
+            ]
         ) . '</p>' .
         '<p><input type="submit" name="upload_pkg" value="' . __('Upload') . '" />' .
@@ -1301,14 +1302,14 @@
         '<h4>' . __('Download a zip file') . '</h4>' .
         '<p class="field"><label for="pkg_url" class="classic required"><abbr title="' . __('Required field') . '">*</abbr> ' . __('Zip file URL:') . '</label> ' .
-        form::field('pkg_url', 40, 255, array(
+        form::field('pkg_url', 40, 255, [
             'extra_html' => 'required placeholder="' . __('URL') . '"'
-        )) .
+        ]) .
         '</p>' .
         '<p class="field"><label for="your_pwd2" class="classic required"><abbr title="' . __('Required field') . '">*</abbr> ' . __('Your password:') . '</label> ' .
-        form::password(array('your_pwd', 'your_pwd2'), 20, 255,
-            array(
+        form::password(['your_pwd', 'your_pwd2'], 20, 255,
+            [
                 'extra_html'   => 'required placeholder="' . __('Password') . '"',
                 'autocomplete' => 'current-password'
-            )
+            ]
         ) . '</p>' .
         '<p><input type="submit" name="fetch_pkg" value="' . __('Download') . '" />' .
@@ -1468,14 +1469,15 @@
      *
      * @param    object    $modules        dcModules instance
-     * @param    string    $modules_root    Modules root directories
+     * @param    string    $modules_root   Modules root directories
      * @param    string    $xml_url        URL of modules feed from repository
-     */
-    public function __construct(dcModules $modules, $modules_root, $xml_url)
-    {
-        parent::__construct($modules, $modules_root, $xml_url);
+     * @param    boolean   $force          Force query repository
+     */
+    public function __construct(dcModules $modules, $modules_root, $xml_url, $force = false)
+    {
+        parent::__construct($modules, $modules_root, $xml_url, $force);
         $this->page_url = $this->core->adminurl->get('admin.blog.theme');
     }
 
-    public function displayModules($cols = array('name', 'config', 'version', 'desc'), $actions = array(), $nav_limit = false)
+    public function displayModules($cols = ['name', 'config', 'version', 'desc'], $actions = [], $nav_limit = false)
     {
         echo
@@ -1517,5 +1519,5 @@
                     $line .=
                     '<label for="' . html::escapeHTML($this->list_id) . '_modules_' . html::escapeHTML($id) . '">' .
-                    form::checkbox(array('modules[' . $count . ']', html::escapeHTML($this->list_id) . '_modules_' . html::escapeHTML($id)), html::escapeHTML($id)) .
+                    form::checkbox(['modules[' . $count . ']', html::escapeHTML($this->list_id) . '_modules_' . html::escapeHTML($id)], html::escapeHTML($id)) .
                     html::escapeHTML($module['name']) .
                         '</label>';
@@ -1523,5 +1525,5 @@
                 } else {
                     $line .=
-                    form::hidden(array('modules[' . $count . ']'), html::escapeHTML($id)) .
+                    form::hidden(['modules[' . $count . ']'], html::escapeHTML($id)) .
                     html::escapeHTML($module['name']);
                 }
@@ -1567,10 +1569,10 @@
                     $line .=
                     '<label for="' . html::escapeHTML($this->list_id) . '_modules_' . html::escapeHTML($id) . '">' .
-                    form::checkbox(array('modules[' . $count . ']', html::escapeHTML($this->list_id) . '_modules_' . html::escapeHTML($id)), html::escapeHTML($id)) .
+                    form::checkbox(['modules[' . $count . ']', html::escapeHTML($this->list_id) . '_modules_' . html::escapeHTML($id)], html::escapeHTML($id)) .
                     html::escapeHTML($module['name']) .
                         '</label>';
                 } else {
                     $line .=
-                    form::hidden(array('modules[' . $count . ']'), html::escapeHTML($id)) .
+                    form::hidden(['modules[' . $count . ']'], html::escapeHTML($id)) .
                     html::escapeHTML($module['name']);
                 }
@@ -1710,5 +1712,5 @@
     protected function getActions($id, $module, $actions)
     {
-        $submits = array();
+        $submits = [];
 
         $this->core->blog->settings->addNamespace('system');
@@ -1730,5 +1732,5 @@
     protected function getGlobalActions($actions, $with_selection = false)
     {
-        $submits = array();
+        $submits = [];
 
         foreach ($actions as $action) {
@@ -1766,5 +1768,5 @@
         }
 
-        $modules = !empty($_POST['modules']) && is_array($_POST['modules']) ? array_values($_POST['modules']) : array();
+        $modules = !empty($_POST['modules']) && is_array($_POST['modules']) ? array_values($_POST['modules']) : [];
 
         if (!empty($_POST['select'])) {
